{This spincode is ment to run pumps in a garden dam at certain intervals.It also controls the fence loop to the robot lawnmower.
Tis is because the mower has to cross the driveway to get to the lawn at area 2, and I won`t let him do so at daytime. He could
possibly be ran over by the traffic and damaged. This code also have a RS-485 driver that talks to my main station for monitoring.
Version 1.0 is developed at June 4. 2015 by LA6WNA, Peter.}

CON

  _CLKMODE = XTAL1 + PLL16X
  _XINFREQ = 5_000_000

  ' Pin configuration:
  ADCdata       = 0             'Data pin for ADC 0834
  RTCcs         = 1             'Chip-select pin for RealTime Clock chip 
  ADCcs         = 2             'Chip-select pin for ADC 0834 
  RTCdata       = 3             'Data pin for RTC
  ADCclk        = 4             'ADC 0834 clock-pin
  RTCclk        = 5             'RTC clock-pin
  DI5           = 6             'Digital Input 5
  RX485         = 7             'RX pin for RS-485 bus driver
  DI4           = 8             'Digital Input 4
  Mode485       = 9             'Mode pin for RS-485 bus driver
  DI3           = 10            'Digital Input 3
  TX485         = 11            'TX pin for RS-485 bus driver
  '             = 12            'Not used
  LEDrx         = 13            'RS-485 RX LED
  DI2           = 14            'Digital input 2
  RLY5          = 15            'Relay output 5
  DI1           = 16            'Digital Input 1
  RLY4          = 17            'Relay output 4
  '             = 18            'Not used
  RLY3          = 19            'Relay output 3
  '             = 20            'Not used
  RLY2          = 21            'Relay output 2
  '             = 22            'Not used
  RLY1          = 23            'Relay output 1
  '             = 24            'Not used
  LEDtx         = 25            'RS-485 TX LED
  
  


  'RS-485 setup
  Baud          = 9600          ' RS485 baud-rate
  CT            = 250           ' RS485 "Carrier"-Time in ms.
  MyID          = 104           ' this stations ID on RS485-bus line
  MainID        = 100           ' main stations ID on RS485-bus line
  
OBJ
   ADC   : "jm_adc0834_ez"
   RTC   : "DS1302_full"
   RS485 : "RS485_Server"
   pst   : "Parallax Serial Terminal" 

VAR

 long RS485Stack [100] , LightStack[20], FlashStack[20]
 byte Ai[5],Di[6],Do[6]
 byte Hour, Minute, Second, Day, Month, Year, DOW, AdjustRTC, Corrected, Flash 
 byte ResID, CallersID
 
PUB  Main 

  pst.Start(19_200)                                   'Start serial terminal driver for debug
  pause(500)

  RTC.init (RTCclk, RTCdata, RTCcs)                   'Start RealTime Clock
  RTC.config
  'RTC.setDatetime (06,04,15,4,14,54,00)               'Activate this string to set clock.(MM.DD.YY.DOW.HH.MM.SS)
                          
  adc.init(ADCcs, ADCclk, ADCdata)                    ' setup ADC

  cognew (GardenLights, @LightStack)

  cognew (FlashLights, @FlashStack)
  
  cognew (RS485communication (RX485,TX485,Mode485), @RS485Stack) 'Start RS-485 server in a new cog

  dira[DI1]~                                          'Config I/O 
  dira[DI2]~
  dira[DI3]~ 
  dira[DI4]~
  dira[DI5]~
  dira[RLY1]~~
  dira[RLY2]~~
  dira[RLY3]~~
  dira[RLY4]~~
  dira[RLY5]~~
  
'**********************MAIN LOOP STARTS FROM HERE***********************************  
  
  repeat

    RTC.readTime (@Hour,@Minute,@Second)               'Read RTC
    RTC.readDate (@Day, @Month, @Year, @DOW)           'Read RTC

    if AdjustRTC==1 and Corrected==0                   'Adjust RTC to match main-station back home.Managed by RS-485 cog.
       RTCcorrection                                   'Make correction
       Corrected:=1                                    'Flag as corrected

    ReadAnalogInputs                                   'Get values
    ReadDigitalInputs                                  'Get values
    
    if Di[5]==1
      GardenDam                                        'Pump control garden dam
    else
      Do[4]:=0
      
    if Di[2]==1
      Lawnmower                                        'Lawnmower loop controller
    else
       Do[1]:=0
       

    if Di[1]==0 and Do[1]==1                           'Flash warning sign by the driveway if area 2 is open and lawnmower is out working.
       Do[2]:=Flash
    else
       Do[2]:=0
          
    SetRelayOutputs                                    'Set output relays
    DebugPST


PUB GardenDam

    if Ai[2]>15 and Ai[1]==0 and Hour=> 15 and DOW<>6 and DOW<>7          'Start assumptions garden dam pump in weekdays
      Do[4]:=1
    if Ai[2]<10 or Ai[1]=>2 or Hour<15 or Hour=>21 and (DOW<>6 and DOW<>7) 'Stop assumptions garden dam pump in weekdays
      Do[4]:=0

    if Ai[2]>15 and Ai[1]==0 and Hour=> 9 and (DOW==6 or DOW==7)          'Start assumptions garden dam pump in weekends
      Do[4]:=1
    if Ai[2]<10 or Ai[1]=>2 or Hour<9 or Hour=>22 and (DOW==6 or DOW==7)  'Stop assumptions garden dam pump in weekends
      Do[4]:=0  


PUB Lawnmower

    if Di[4]==1
      Do[1]:=1
      return
        


    if Hour=>0 and Hour<5 and DOW<>6 and DOW<>7 and Di[1]==1 and Do[1]==0  'Opens loop for lawnmower at nighttime so it can reach area 2
      Do[1]:=1
   
    
    if Hour=>5 and Di[1]==1 and Do[1]==1                                   'Closing loop for area 2
      Do[1]:=0


PUB GardenLights |a,b

   a:=b:=0
   
   repeat
    if Ai[4]<20                                                'Starts delay ON
      a++
    else
      a:=0

    if Ai[4]=>20                                               'Starts delay OFF
      b++
    else
      b:=0

    if a>30 and Do[5]==0                                       'Turn on lights afther delay time
      Do[5]:=1
    if b>30 and Do[5]==1                                       'Turn off lights afther delay time
      Do[5]:=0

    waitcnt(((clkfreq / 1_000 * 1000 - 3932) #> 381) + cnt)     'One second loop
    

PUB FlashLights

    repeat
      !Flash
      waitcnt(((clkfreq / 1_000 * 1000 - 3932) #> 381) + cnt)     'One second loop
      
  
PUB ReadAnalogInputs  |i,v

  v:=0
  repeat i from 1 to 4                                 'Analog input 1-4
    Ai[i]:=ADC.read(v)
    v+=1

PUB ReadDigitalInputs 

    if ina[DI1]==0
      Di[1]:=1
    else
      Di[1]:=0
    if ina[DI2]==0
      Di[2]:=1
    else
      Di[2]:=0
    if ina[DI3]==0
      Di[3]:=1
    else
      Di[3]:=0
    if ina[DI4]==0
      Di[4]:=1
    else
      Di[4]:=0  
    if ina[DI5]==0
      Di[5]:=1
    else
      Di[5]:=0

    
PUB SetRelayOutputs

   if Do[1]<>0
      outa [RLY1]~~
   else  
      outa [RLY1]~
   if Do[2]<>0
      outa [RLY2]~~
   else  
      outa [RLY2]~
   if Do[3]<>0
      outa [RLY3]~~
   else  
      outa [RLY3]~
   if Do[4]<>0
      outa [RLY4]~~
   else  
      outa [RLY4]~
   if Do[5]<>0
      outa [RLY5]~~
   else  
      outa [RLY5]~
        

PRI TestIO

    if Di[1]==1
       Do[1]:=1
    else
       Do[1]:=0
       
    if Di[2]==1
       Do[2]:=1
    else
       Do[2]:=0

    if Di[3]==1
       Do[3]:=1
    else
       Do[3]:=0

    if Di[4]==1
       Do[4]:=1
    else
       Do[4]:=0

    if Di[5]==1
       Do[5]:=1
    else
       Do[5]:=0

              
PUB RS485communication (rxpin,txpin,modepin)

   RS485.startSerial (rxpin,txpin,modepin,Baud)        ' Start RS-485 driver

   dira[LEDrx]~~                                       'Set LED-pins as outputs
   dira[LEDtx]~~
   
   repeat
     Put_TXbuffer                                      'Get data ready to be sent from TXbuffer
     if ina[rxpin]==0                                  ' "Carrier" present. Go receive ID
       outa[LEDrx]~~ 
       ReceiveID
       outa[LEDrx]~
       
     if ResID==MyID and CallersID==MainID              'If main station calls me, send data back
       outa[LEDtx]~~                                   'elseif, hang on listening
       Call_Main                              
       CallersID:=0
       outa[LEDtx]~

       
PRI Put_TXbuffer|i

  
   repeat i from 2 to 5             'Analog inputs
     RS485.PutTX(i,Ai[i-1])

   repeat i from 6 to 10            'Digital inputs
     RS485.PutTX(i,Di[i-5])

   repeat i from 11 to 15           'Relay outputs
     RS485.PutTX(i,Do[i-10])

   RS485.PutTX(16,Hour)  
   RS485.PutTX(17,Minute)
   RS485.PutTX(18,Second)
   RS485.PutTX(19,DOW)
   RS485.PutTX(20,Day)
   RS485.PutTX(21,Month)
   RS485.PutTX(22,Year)
               

       
PRI ReceiveID

    ResID:=CallersID:=0
    
    ResID := RS485.ReceiveID              'Who is called?
    CallersID := RS485.ReceiveID          'Who`s calling?
    if ResID==MyID and CallersID==MainID  'If main station calls me, receive data in buffer A
      RS485.Receive_A
      
      if (RS485.GetRX_A(6))==4 and (RS485.GetRX_A(7))==30 and AdjustRTC==0     'Adjust RTC to match master station's RTC
        AdjustRTC:=1

      if (RS485.GetRX_A(6))==4 and (RS485.GetRX_A(7))==29 and AdjustRTC==1     'Get ready to adjust RTC
        AdjustRTC:=Corrected:=0  
        
      return
    waitcnt(80_000_000+cnt)               'Time to let other stations answer, if the call
                                          'was`nt ment for me.
    
PRI Call_Main

    RS485.PutTX (0,23 )            ' put number of bytes to send into TXA[0]
    RS485.PutTX (1,MyID)           ' put "MyID" into TXA[1]
    RS485.Call_Station (MainID,MyID,CT)
    RS485.Send_DataBuffer
    waitcnt(30_000_000+cnt)       ' time to show "TX-flag" at TV screen
       
PRI pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)

PRI RTCcorrection  |Mo,Da,Ye,Dnum,Ho,Mi,Se

    Da:=(RS485.GetRX_A(2))
    Mo:=(RS485.GetRX_A(3))
    Ye:=(RS485.GetRX_A(4))
    Dnum:=(RS485.GetRX_A(5))
    Ho:=(RS485.GetRX_A(6))
    Mi:=(RS485.GetRX_A(7))
    Se:=(RS485.GetRX_A(8))
    
    RTC.setDatetime (Mo,Da,Ye,Dnum,Ho,Mi,Se)  'Adjusting RTC .(MM.DD.YY.DOW.HH.MM.SS)

PRI DebugPST |i

    pst.Home
    pst.str(string("Debug values for garden dam and lawnmower control."))
    pst.NewLine
    pst.str(string("TIME :   "))
    pst.dec(Day)
    pst.str(string("."))
    pst.dec(Month)
    pst.str(string("."))
    pst.dec(Year+2000)
    pst.str(string("-----"))
    pst.dec(Hour)
    pst.str(string(":"))
    pst.dec(Minute)
    pst.str(string(":"))
    pst.dec(Second)
    pst.str(string("-----Day: "))
    pst.dec(DOW)
    pst.NewLine
    pst.NewLine
    pst.str(string("Digital inputs :   "))
    repeat i from 1 to 5
      pst.dec(Di[i])
    pst.NewLine
    pst.NewLine
    pst.str(string("Analog inputs  :   "))
    repeat i from 1 to 4
      pst.dec(Ai[i])
      pst.str(string(" , "))
    pst.NewLine
    pst.NewLine
    pst.str(string("Relay outputs  :   "))
    repeat i from 1 to 5
      pst.dec(Do[i])
    pst.NewLine
    pst.NewLine
    pst.str(string("RS-485 communication :  "))
    pst.str(string("  ResID:"))
    pst.dec(ResID)
    pst.str(string("  CallersID:"))
    pst.dec(CallersID)

    